
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include "resource.h"

static TCHAR lpszAppName[] = TEXT( "API Windows" );

long xPos = 0;
long cPass = 0;
RECT rect = {0,10,0,40};
clock_t time_on = 0, time_last;
CHAR szPassTime[200];
TCHAR wsPassTime[200];
HBITMAP hbmp;
BOOLEAN bBitmap = TRUE;

void OnPaint(HWND wnd, HDC hdc) {

  if (xPos==0) {
    time_last = clock();
    if (!time_on) { time_on = time_last; }
    }
  if (++xPos>500) {
    double fPassTime, fPassTimeA;
    xPos=0;
    fPassTime = clock() - time_last;
    fPassTime /= CLOCKS_PER_SEC;
    fPassTimeA = clock() - time_on;
    fPassTimeA /= (++cPass * CLOCKS_PER_SEC);
    sprintf(szPassTime, "pass time avg:%.3g last:%.3g [s]", fPassTimeA, fPassTime);
    wsprintf(wsPassTime, "%hs", szPassTime);
    InvalidateRect(wnd, NULL, TRUE);
    }
  PAINTSTRUCT ps;
  if (BeginPaint(wnd, &ps)) {
    rect.left = xPos;
    rect.right = rect.left + rect.bottom - rect.top;
    FrameRect(ps.hdc, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));
    if (*szPassTime) {
      SelectObject(ps.hdc, GetStockObject(SYSTEM_FONT));
      SelectObject(ps.hdc, GetStockObject(BLACK_BRUSH));
      TextOut(ps.hdc, 10,80, wsPassTime, lstrlen(wsPassTime));
      }

    if (bBitmap) {
      HDC hdcmem = CreateCompatibleDC(ps.hdc);
      //HBITMAP hbmpcomp = CreateCompatibleBitmap
      SelectObject(hdcmem, hbmp);
      BitBlt(ps.hdc, rect.left+2, rect.top+2, rect.right-rect.left - 4, rect.bottom - rect.top - 4, hdcmem, 0, 0, SRCCOPY);
      DeleteDC(hdcmem);
      }

    EndPaint(wnd, &ps);
    }
  //PostMessage(wnd, WM_ERASEBKGND, (WPARAM)hdc, 0);
  //PostMessage(wnd, WM_PAINT, (WPARAM)hdc, 0);
  //InvalidateRect(wnd, NULL, FALSE);
  PostMessage(wnd, WM_USER, (WPARAM)hdc, 0);
  //puts("paint");
  }

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)

{
switch (uMsg)
{

case WM_CREATE:

break;

case WM_PAINT:
OnPaint(hWnd, (HDC)wParam);
break;

case WM_USER:
  {
  InvalidateRect(hWnd, &rect, FALSE);
  RECT rectClear = { rect.left, rect.top, rect.left+1, rect.bottom };
  InvalidateRect(hWnd, &rectClear, TRUE);
  }
  break;

case WM_DESTROY:

PostQuitMessage(0);
break;

case WM_KEYDOWN:
break;

default:

return (DefWindowProc(hWnd, uMsg, wParam, lParam));

}
return(0L);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)

{

MSG msg;
WNDCLASS wndclass;
HWND hWnd;

szPassTime[0] = 0;
hbmp = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAP1));
printf("hbmp=%ld\n", hbmp);
puts(lpCmdLine);
if (strcmp(lpCmdLine, "t")==0) { bBitmap = FALSE; }

wndclass.style = CS_HREDRAW | CS_VREDRAW;
wndclass.lpfnWndProc = MainWndProc;
wndclass.cbClsExtra = 0;
wndclass.cbWndExtra = 0;
wndclass.hInstance = hInstance;
wndclass.hIcon = NULL;
wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
wndclass.lpszMenuName = NULL;
wndclass.lpszClassName = lpszAppName;

if(RegisterClass(&wndclass) == 0)

return FALSE;

hWnd = CreateWindow(lpszAppName, lpszAppName,
WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
CW_USEDEFAULT, CW_USEDEFAULT,
CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
if(hWnd == NULL)
return FALSE;

ShowWindow(hWnd, SW_SHOW);
UpdateWindow(hWnd);

while(GetMessage(&msg, NULL, 0, 0))
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}

return msg.wParam;
}

